	
// MyTreeControl.h : Declaration of the CMyTreeControl

#ifndef __MYTREECONTROL_H_
#define __MYTREECONTROL_H_

#include "resource.h"       // main symbols
#include <atlctl.h>
#include <commctrl.h>
#include <statreg.h>
#include "AddTreeItem.h"
#include "Tree.h"

#define IMAGEWIDTH		18
#define IMAGEGROWBY		3
#define IMAGE				0
#define IMAGESELECT		1
#define IMAGEVALTEXT		2
#define IMAGEVALBIN		3
#define IMAGECOUNT		3
/////////////////////////////////////////////////////////////////////////////
// CMyTreeControl
class ATL_NO_VTABLE CMyTreeControl : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CStockPropImpl<CMyTreeControl, IMyTreeControl, &IID_IMyTreeControl, &LIBID_ATLTREECONTROLLib>,
	public CComControl<CMyTreeControl>,
	public IPersistStreamInitImpl<CMyTreeControl>,
	public IOleControlImpl<CMyTreeControl>,
	public IOleObjectImpl<CMyTreeControl>,
	public IOleInPlaceActiveObjectImpl<CMyTreeControl>,
	public IViewObjectExImpl<CMyTreeControl>,
	public IOleInPlaceObjectWindowlessImpl<CMyTreeControl>,
	public IConnectionPointContainerImpl<CMyTreeControl>,
	public IPersistStorageImpl<CMyTreeControl>,
	public ISpecifyPropertyPagesImpl<CMyTreeControl>,
	public IQuickActivateImpl<CMyTreeControl>,
	public IDataObjectImpl<CMyTreeControl>,
	public IProvideClassInfo2Impl<&CLSID_MyTreeControl, &DIID__IMyTreeControlEvents, &LIBID_ATLTREECONTROLLib>,
	public IPropertyNotifySinkCP<CMyTreeControl>,
	public CComCoClass<CMyTreeControl, &CLSID_MyTreeControl>
{
public:
	CContainedWindow m_ctlSysTreeView32;
	HIMAGELIST  m_hImageList;
	HMENU			m_hRightMenu;
	HMENU			m_hLoadMenu;
	HTREEITEM	m_hAtRoot;
	HTREEITEM	m_hti;
	HTREEITEM	m_hChildItem;
	HTREEITEM	m_hTreeItemDrop;
	HTREEITEM	m_hTreeItemOldDrop;
	HTREEITEM	m_hTreeItemDrag;
	OLE_COLOR	m_oleFourColor;
	COLORREF		m_clrFourColor;
	CComBSTR		m_strPath;
	LPCTSTR		m_szFilter;
	BOOL			m_bDragging;
	UINT			m_idTimer;
	CWindow		m_hWindow;
	TCHAR*		m_lpszConnect;

	TV_INSERTSTRUCT TreeCtrlItem;

	CMyTreeControl() :	
		m_ctlSysTreeView32(_T("SysTreeView32"), this, 1)
	{
		m_pUnkMarshaler = NULL;
		//	Filter the Open Dialog Box with extension "< .CPP >"
		m_szFilter = _T("Any Files\x00*.cpp\x00");
		m_bWindowOnly = TRUE;
		m_bDragging = FALSE;
		m_clrFillColor = RGB(0, 0xFF, 0);
		CreatePopup();
	}
	// When the Class Wizard Generated this class, no destructor at all.
	// So I have to manually created by HAND. I did not know they not generate
	// destructor for purpose or just forgotten to implement it.
	~CMyTreeControl()
	{
		// Clean up all the resource we were allocated in the process of the
		// application, make sure the resource is release back to the system, which
		// we were borrow to use our application.
		if(m_hRightMenu != NULL)
			DestroyMenu(m_hRightMenu);
		if(m_hImageList != NULL)
			ImageList_Destroy(m_hImageList);
		if(m_hWindow)
			m_hWindow = NULL;
		delete [] m_lpszConnect;
		m_lpszConnect = NULL;
	}

	enum ContentType
	{
		Replacement = 0,
		DefaultVal = 1,
		NamedVal = 2,
		Key = 3,
		RootKey = 4
	};

DECLARE_GET_CONTROLLING_UNKNOWN()
DECLARE_REGISTRY_RESOURCEID(IDR_MYTREECONTROL)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CMyTreeControl)
	COM_INTERFACE_ENTRY(IMyTreeControl)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IViewObjectEx)
	COM_INTERFACE_ENTRY(IViewObject2)
	COM_INTERFACE_ENTRY(IViewObject)
	COM_INTERFACE_ENTRY(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceObject)
	COM_INTERFACE_ENTRY2(IOleWindow, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY(IOleControl)
	COM_INTERFACE_ENTRY(IOleObject)
	COM_INTERFACE_ENTRY(IPersistStreamInit)
	COM_INTERFACE_ENTRY2(IPersist, IPersistStreamInit)
	COM_INTERFACE_ENTRY(IConnectionPointContainer)
	COM_INTERFACE_ENTRY(ISpecifyPropertyPages)
	COM_INTERFACE_ENTRY(IQuickActivate)
	COM_INTERFACE_ENTRY(IPersistStorage)
	COM_INTERFACE_ENTRY(IDataObject)
	COM_INTERFACE_ENTRY(IProvideClassInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo2)
	COM_INTERFACE_ENTRY_AGGREGATE(IID_IMarshal, m_pUnkMarshaler.p)
END_COM_MAP()

BEGIN_PROP_MAP(CMyTreeControl)
	PROP_DATA_ENTRY("_cx", m_sizeExtent.cx, VT_UI4)
	PROP_DATA_ENTRY("_cy", m_sizeExtent.cy, VT_UI4)
	PROP_ENTRY("AutoSize", DISPID_AUTOSIZE, CLSID_NULL)
	PROP_ENTRY("BackStyle", DISPID_BACKSTYLE, CLSID_NULL)
	PROP_ENTRY("BorderColor", DISPID_BORDERCOLOR, CLSID_StockColorPage)
	PROP_ENTRY("BorderStyle", DISPID_BORDERSTYLE, CLSID_NULL)
	PROP_ENTRY("BorderVisible", DISPID_BORDERVISIBLE, CLSID_NULL)
	PROP_ENTRY("BorderWidth", DISPID_BORDERWIDTH, CLSID_NULL)
	PROP_ENTRY("Enabled", DISPID_ENABLED, CLSID_NULL)
	PROP_ENTRY("FillColor", DISPID_FILLCOLOR, CLSID_StockColorPage)
	PROP_ENTRY("FillStyle", DISPID_FILLSTYLE, CLSID_NULL)
	PROP_ENTRY("ForeColor", DISPID_FORECOLOR, CLSID_StockColorPage)
	PROP_ENTRY("HWND", DISPID_HWND, CLSID_NULL)
	// Example entries
	// PROP_ENTRY("Property Description", dispid, clsid)
	// PROP_PAGE(CLSID_StockColorPage)
END_PROP_MAP()

BEGIN_CONNECTION_POINT_MAP(CMyTreeControl)
	CONNECTION_POINT_ENTRY(IID_IPropertyNotifySink)
END_CONNECTION_POINT_MAP()

BEGIN_MSG_MAP(CMyTreeControl)
//	MESSAGE_HANDLER(WM_PAINT, OnPaint)
	MESSAGE_HANDLER(WM_CREATE, OnCreate)
	MESSAGE_HANDLER(WM_SETFOCUS, OnSetFocus)
	NOTIFY_CODE_HANDLER(TVN_BEGINDRAG, OnBegindrag)
	NOTIFY_CODE_HANDLER(TVN_ENDLABELEDIT, OnEndEditLabel);
	CHAIN_MSG_MAP(CComControl<CMyTreeControl>)
ALT_MSG_MAP(1)
	// Replace this with message map entries for superclassed SysTreeView32
	MESSAGE_HANDLER(WM_LBUTTONDBLCLK, OnLButtonDblClk)
	MESSAGE_HANDLER(WM_MOUSEMOVE, OnMouseMove)
	MESSAGE_HANDLER(WM_DESTROY, OnDestroy)
	MESSAGE_HANDLER(WM_RBUTTONDOWN, OnRButtonDown)
	MESSAGE_HANDLER(WM_RBUTTONUP, OnRButtonUp)
	MESSAGE_HANDLER(WM_KEYDOWN, OnKeyDown)
	COMMAND_ID_HANDLER(IDM_INSERT, OnNew)
	COMMAND_ID_HANDLER(IDM_OPEN, OnOpen)
	COMMAND_ID_HANDLER(IDM_DELETE, OnDelete)
	COMMAND_ID_HANDLER(IDM_ADDKEY, OnAddKey)
	COMMAND_ID_HANDLER(IDM_RENAME, OnRename)
	MESSAGE_HANDLER(WM_LBUTTONUP, OnLButtonUP)
ALT_MSG_MAP(2)
//MESSAGE_HANDLER(WM_LBUTTONUP, OnLButtonUP) Wizard insert the message but put it in the wrong place
END_MSG_MAP()
// Handler prototypes:
//  LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//  LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
//  LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);

	// When you perform a right click on the tree item, this function
	// in open the menu, recognize as POPUP-MENU
	void CreatePopup()
	{
		m_hRightMenu = NULL;
		// If you are SDK programmer,
		// _Module.GetResourceInstance() equivalent as AfxGetInstanceHandle
		m_hLoadMenu = LoadMenu(_Module.GetResourceInstance(), MAKEINTRESOURCE(IDR_RIGHTMENU));
		if (m_hLoadMenu == NULL)
		{
			ATLTRACE(_T("Failed to load right click menu\n"));
			_ASSERTE(FALSE);
			return;
		}

		m_hRightMenu = GetSubMenu(m_hLoadMenu, 0);
		if (m_hRightMenu == NULL)
		{
			ATLTRACE(_T("Failed to load Popup menu\n"));
			_ASSERTE(FALSE);
			return;
		}
	}

	// This function retrieve the indent level of an item in the tree
	// when we know its parent
	/******************************************************** 
	First  Parent					indent level ZERO
		First Child					indent level one
			Second Child			indent level two
			Third  Child			indent level two
	Second Parent					indent level ZERO
		Fourth Child				indent level one
		Fifth  Child				indent level one
			Six	 Child			indent level two
				Seven	 Child		indent level three
					Eight  Child	indent level fourth
	*********************************************************/
	int GetIndentLevel(HTREEITEM hItem)
	{
		int iIndent = 0;
		
		while((hItem = TreeView_GetParent(this->m_ctlSysTreeView32.m_hWnd, hItem)) != NULL)
			iIndent++;
		return iIndent;
	}

	// This Function insert the item any where in the tree control depend on
	// the special argument which is "< hParent >". If you haven't provide hParent
	// By default, the newly insert item alway have no parent associate with it.
	// this mean that it is the top item( Parent Item by itself ).
	// By examine this function, if you have an array which contain string,
	// you put this function into the loop and you can fill the entire tree with your
	// string array. Take look at my "OnCreate(...)" function, it is a mile long
	// ( NO GOOD ), but while I did not use this function, because I would like to
	// tell you the basic to create tree control, which I was started to learn how
	// to code for tree control
	HTREEITEM InsertItem(HWND hWnd, LPCTSTR lpszItem, int iImage, int iSelectImage, LPARAM lParam,
						 HTREEITEM hParent = TVI_ROOT, HTREEITEM hAfter = TVI_LAST)
	{
		_ASSERTE(::IsWindow(hWnd));
		TV_INSERTSTRUCT tvis;
		::ZeroMemory(&tvis, sizeof(TV_INSERTSTRUCT));

		tvis.hParent = hParent;
		tvis.hInsertAfter = hAfter;
		tvis.item.mask = TVIF_TEXT | TVIF_IMAGE | TVIF_SELECTEDIMAGE | TVIF_PARAM;
		tvis.item.cchTextMax = 80;
		tvis.item.pszText = (LPTSTR)lpszItem;
		tvis.item.iImage = 0;
		tvis.item.iSelectedImage = 1;
		tvis.item.state = 0;
		tvis.item.stateMask = 0;
		tvis.item.lParam = lParam;
		return (HTREEITEM)::SendMessage(hWnd, TVM_INSERTITEM, 0, (LPARAM)&tvis);
	}

	// This function use to set specific data belong to the newly
	// insert item, use for specific purpose. It can be CUSTOMER_ID,
	// INVOID_NO and so on...It must be unique number, can not be duplicate.
	// I will use this number to open difference Dialog later in the example process.
	void SetLParam(HTREEITEM hItem, LPARAM lParam)
	{
		TV_ITEM tvi;

		tvi.mask = TVIF_PARAM;
		tvi.hItem = hItem;
		tvi.lParam = lParam;
		TreeView_SetItem(m_ctlSysTreeView32.m_hWnd, &tvi);
	}

	// Retrieve the number which the function above use to set.
	void GetLParam(HTREEITEM hItem, LPARAM& lParam)
	{
		TV_ITEM tvi;

		tvi.mask = TVIF_PARAM;
		tvi.hItem = hItem;
		TreeView_GetItem(m_ctlSysTreeView32.m_hWnd, &tvi);
		lParam = tvi.lParam;
	}

	// This function generated by App Wizard which filter out the affection
	// of the user when they hit any key on the keyboard( NOTHING HAPPEN )
	BOOL PreTranslateAccelerator(LPMSG pMsg, HRESULT& hRet)
	{
		if(pMsg->message == WM_KEYDOWN && 
			(pMsg->wParam == VK_LEFT || 
			pMsg->wParam == VK_RIGHT || 
			pMsg->wParam == VK_UP ||	 
			pMsg->wParam == VK_DOWN))
		{
			hRet = S_FALSE;
			return TRUE;
		}
		//TODO: Add your additional accelerator handling code here
		return FALSE;
	}

	LRESULT OnSetFocus(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		LRESULT lRes = CComControl<CMyTreeControl>::OnSetFocus(uMsg, wParam, lParam, bHandled);
		if (m_bInPlaceActive)
		{
			DoVerbUIActivate(&m_rcPos,  NULL);
			if(!IsChild(::GetFocus()))
				m_ctlSysTreeView32.SetFocus();
		}
		return lRes;
	}

	LRESULT OnCreate(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
	{
		RECT rc;
		GetWindowRect(&rc);
		rc.right -= rc.left+9;
		rc.top = rc.left = 0;
		InflateRect(&rc, -2, -2);
		InitCommonControls();
		m_ctlSysTreeView32.Create(m_hWnd, rc, "SysTreeView32", 
			WS_VISIBLE | WS_CHILD | TVS_LINESATROOT | TVS_HASLINES | TVS_EDITLABELS | 
			TVS_HASBUTTONS | TVS_FULLROWSELECT | TVS_SHOWSELALWAYS, WS_EX_CLIENTEDGE, 0);

		m_hImageList = ImageList_LoadBitmap(_Module.GetModuleInstance(),
		MAKEINTRESOURCE(IDR_IMAGELIST), IMAGEWIDTH, IMAGEGROWBY, OleTranslateColor(m_oleFourColor, NULL, &m_clrFourColor));
		_ASSERTE(m_ctlSysTreeView32.m_hWnd != NULL);
		_ASSERTE(m_hImageList != NULL);
		TreeView_SetImageList(m_ctlSysTreeView32.m_hWnd, m_hImageList, TVSIL_NORMAL);
	
		this->PopulateTreeManually();

		return 0;
	}

	HTREEITEM InsertSubTree(HTREEITEM hti, int& iCheck, LPTSTR lpszItemName, int iIndentLevel, LONG lData)
	{
		if(iCheck < iIndentLevel)
		{
			iCheck = iIndentLevel;
			hti = this->InsertItem(m_ctlSysTreeView32.m_hWnd,   
				lpszItemName, IMAGE, IMAGESELECT, MAKELPARAM(DefaultVal, 0L), hti);
			this->SetLParam(hti, MAKELPARAM(lData, 0L));
		}
		else if(iCheck == iIndentLevel)
		{
			hti = TreeView_GetParent(this->m_ctlSysTreeView32.m_hWnd, hti);
			hti = this->InsertItem(m_ctlSysTreeView32.m_hWnd,   
				lpszItemName, IMAGE, IMAGESELECT, MAKELPARAM(DefaultVal, 0L), hti);
			this->SetLParam(hti, MAKELPARAM(lData, 0L));
		}
		else 
		{
			while(iCheck-- >= iIndentLevel)  // iCheck must be greater than iIndentLevel because
				hti = TreeView_GetParent(this->m_ctlSysTreeView32.m_hWnd, hti);
			// When the loop terminated, make sure iCheck is equal to iIndent
			iCheck = iIndentLevel;
			hti = this->InsertItem(m_ctlSysTreeView32.m_hWnd,   
				lpszItemName, IMAGE, IMAGESELECT, MAKELPARAM(DefaultVal, 0L), hti);
			this->SetLParam(hti, MAKELPARAM(lData, 0L));
		}
		return hti;
	}

	void PopulateTreeManually()
	{
		TreeCtrlItem.hParent = TVI_ROOT;
		TreeCtrlItem.hInsertAfter = TVI_LAST;
		TreeCtrlItem.item.mask = TVIF_TEXT | TVIF_IMAGE |TVIF_PARAM | TVIF_SELECTEDIMAGE;
		TreeCtrlItem.item.pszText = "CHARLIE";
		TreeCtrlItem.item.iImage = 0;
		TreeCtrlItem.item.iSelectedImage = 1;
		TreeCtrlItem.item.lParam = 155;
		m_hAtRoot = reinterpret_cast<HTREEITEM>(m_ctlSysTreeView32.SendMessage(TVM_INSERTITEM , 
			0, reinterpret_cast<LPARAM>(&TreeCtrlItem)));

		TreeCtrlItem.hParent = m_hAtRoot;
		TreeCtrlItem.hInsertAfter = TVI_LAST;
		TreeCtrlItem.item.mask = TVIF_TEXT | TVIF_IMAGE |TVIF_PARAM | TVIF_SELECTEDIMAGE;
		TreeCtrlItem.item.pszText = "ELCATO KOTO";
		TreeCtrlItem.item.iImage = 0;
		TreeCtrlItem.item.iSelectedImage = 1;
		TreeCtrlItem.item.lParam = 254;
		m_hChildItem = reinterpret_cast<HTREEITEM>(m_ctlSysTreeView32.SendMessage(TVM_INSERTITEM,
			0, reinterpret_cast<LPARAM>(&TreeCtrlItem)));

		TreeCtrlItem.hParent = m_hChildItem;
		TreeCtrlItem.hInsertAfter = TVI_LAST;
		TreeCtrlItem.item.mask = TVIF_TEXT | TVIF_IMAGE |TVIF_PARAM | TVIF_SELECTEDIMAGE;
		TreeCtrlItem.item.pszText = "TIMMY NORIN";
		TreeCtrlItem.item.iImage = 0;
		TreeCtrlItem.item.iSelectedImage = 1;
		TreeCtrlItem.item.lParam = 432;
		m_ctlSysTreeView32.SendMessage(TVM_INSERTITEM,
			0, reinterpret_cast<LPARAM>(&TreeCtrlItem));

		TreeCtrlItem.hParent = m_hChildItem;
		TreeCtrlItem.hInsertAfter = TVI_LAST;
		TreeCtrlItem.item.mask = TVIF_TEXT | TVIF_IMAGE |TVIF_PARAM | TVIF_SELECTEDIMAGE;
		TreeCtrlItem.item.pszText = "KIM THOMPSON";
		TreeCtrlItem.item.iImage = 0;
		TreeCtrlItem.item.iSelectedImage = 1;
		TreeCtrlItem.item.lParam = 900;
		m_ctlSysTreeView32.SendMessage(TVM_INSERTITEM,
			0, reinterpret_cast<LPARAM>(&TreeCtrlItem));

		TreeCtrlItem.hParent = m_hChildItem;
		TreeCtrlItem.hInsertAfter = TVI_LAST;
		TreeCtrlItem.item.mask = TVIF_TEXT | TVIF_IMAGE |TVIF_PARAM | TVIF_SELECTEDIMAGE;
		TreeCtrlItem.item.pszText = "CHRISTINE";
		TreeCtrlItem.item.iImage = 0;
		TreeCtrlItem.item.iSelectedImage = 1;
		TreeCtrlItem.item.lParam = 452;
		m_ctlSysTreeView32.SendMessage(TVM_INSERTITEM,
			0, reinterpret_cast<LPARAM>(&TreeCtrlItem));

		TreeCtrlItem.hParent = m_hChildItem;
		TreeCtrlItem.hInsertAfter = TVI_LAST;
		TreeCtrlItem.item.mask = TVIF_TEXT | TVIF_IMAGE |TVIF_PARAM | TVIF_SELECTEDIMAGE;
		TreeCtrlItem.item.pszText = "FRANK ROSELLY";
		TreeCtrlItem.item.iImage = 0;
		TreeCtrlItem.item.iSelectedImage = 1;
		TreeCtrlItem.item.lParam = 752;
		m_ctlSysTreeView32.SendMessage(TVM_INSERTITEM,
			0, reinterpret_cast<LPARAM>(&TreeCtrlItem));

		TreeCtrlItem.hParent = m_hAtRoot;
		TreeCtrlItem.hInsertAfter = TVI_LAST;
		TreeCtrlItem.item.mask = TVIF_TEXT | TVIF_IMAGE |TVIF_PARAM | TVIF_SELECTEDIMAGE;
		TreeCtrlItem.item.pszText = "RAYMOND";
		TreeCtrlItem.item.iImage = 0;
		TreeCtrlItem.item.iSelectedImage = 1;
		TreeCtrlItem.item.lParam = 598;
		m_hChildItem = reinterpret_cast<HTREEITEM>(m_ctlSysTreeView32.SendMessage(TVM_INSERTITEM,
			0, reinterpret_cast<LPARAM>(&TreeCtrlItem)));

		TreeCtrlItem.hParent = m_hChildItem;
		TreeCtrlItem.hInsertAfter = TVI_LAST;
		TreeCtrlItem.item.mask = TVIF_TEXT | TVIF_IMAGE |TVIF_PARAM | TVIF_SELECTEDIMAGE;
		TreeCtrlItem.item.pszText = "LYNDA FRONCO";
		TreeCtrlItem.item.iImage = 0;
		TreeCtrlItem.item.iSelectedImage = 1;
		TreeCtrlItem.item.lParam = 258;
		m_ctlSysTreeView32.SendMessage(TVM_INSERTITEM,
			0, reinterpret_cast<LPARAM>(&TreeCtrlItem));

		TreeCtrlItem.hParent = m_hChildItem;
		TreeCtrlItem.hInsertAfter = TVI_LAST;
		TreeCtrlItem.item.mask = TVIF_TEXT | TVIF_IMAGE |TVIF_PARAM | TVIF_SELECTEDIMAGE;
		TreeCtrlItem.item.pszText = "MICHAEL MULAN";
		TreeCtrlItem.item.iImage = 0;
		TreeCtrlItem.item.iSelectedImage = 1;
		TreeCtrlItem.item.lParam = 831;
		m_ctlSysTreeView32.SendMessage(TVM_INSERTITEM,
			0, reinterpret_cast<LPARAM>(&TreeCtrlItem));

		TreeCtrlItem.hParent = m_hAtRoot;
		TreeCtrlItem.hInsertAfter = TVI_LAST;
		TreeCtrlItem.item.mask = TVIF_TEXT | TVIF_IMAGE |TVIF_PARAM | TVIF_SELECTEDIMAGE;
		TreeCtrlItem.item.pszText = "JAY EDMOND";
		TreeCtrlItem.item.iImage = 0;
		TreeCtrlItem.item.iSelectedImage = 1;
		TreeCtrlItem.item.lParam = 100;
		m_hChildItem = reinterpret_cast<HTREEITEM>(m_ctlSysTreeView32.SendMessage(TVM_INSERTITEM,
			0, reinterpret_cast<LPARAM>(&TreeCtrlItem)));

		TreeCtrlItem.hParent = TVI_ROOT;
		TreeCtrlItem.hInsertAfter = TVI_LAST;
		TreeCtrlItem.item.mask = TVIF_TEXT | TVIF_IMAGE |TVIF_PARAM | TVIF_SELECTEDIMAGE;
		TreeCtrlItem.item.pszText = "KATHY GRAND";
		TreeCtrlItem.item.iImage = 0;
		TreeCtrlItem.item.iSelectedImage = 1;
		TreeCtrlItem.item.lParam = 456;
		m_hAtRoot = reinterpret_cast<HTREEITEM>(m_ctlSysTreeView32.SendMessage(TVM_INSERTITEM , 
			0, reinterpret_cast<LPARAM>(&TreeCtrlItem)));

		TreeCtrlItem.hParent = m_hAtRoot;
		TreeCtrlItem.hInsertAfter = TVI_LAST;
		TreeCtrlItem.item.mask = TVIF_TEXT | TVIF_IMAGE |TVIF_PARAM | TVIF_SELECTEDIMAGE;
		TreeCtrlItem.item.pszText = "ARBIGEL HATROMY";
		TreeCtrlItem.item.iImage = 0;
		TreeCtrlItem.item.iSelectedImage = 1;
		TreeCtrlItem.item.lParam = 279;
		m_hChildItem = reinterpret_cast<HTREEITEM>(m_ctlSysTreeView32.SendMessage(TVM_INSERTITEM,
			0, reinterpret_cast<LPARAM>(&TreeCtrlItem)));

		TreeCtrlItem.hParent = m_hChildItem;
		TreeCtrlItem.hInsertAfter = TVI_LAST;
		TreeCtrlItem.item.mask = TVIF_TEXT | TVIF_IMAGE |TVIF_PARAM | TVIF_SELECTEDIMAGE;
		TreeCtrlItem.item.pszText = "THOMPSON HALLY";
		TreeCtrlItem.item.iImage = 0;
		TreeCtrlItem.item.iSelectedImage = 1;
		TreeCtrlItem.item.lParam = 483;
		m_hChildItem = reinterpret_cast<HTREEITEM>(m_ctlSysTreeView32.SendMessage(TVM_INSERTITEM,
			0, reinterpret_cast<LPARAM>(&TreeCtrlItem)));

		TreeCtrlItem.hParent = m_hAtRoot;
		TreeCtrlItem.hInsertAfter = TVI_LAST;
		TreeCtrlItem.item.mask = TVIF_TEXT | TVIF_IMAGE |TVIF_PARAM | TVIF_SELECTEDIMAGE;
		TreeCtrlItem.item.pszText = "HIMA KALLY";
		TreeCtrlItem.item.iImage = 0;
		TreeCtrlItem.item.iSelectedImage = 1;
		TreeCtrlItem.item.lParam = 892;
		m_hChildItem = reinterpret_cast<HTREEITEM>(m_ctlSysTreeView32.SendMessage(TVM_INSERTITEM,
			0, reinterpret_cast<LPARAM>(&TreeCtrlItem)));
		
		TreeView_SetImageList(m_ctlSysTreeView32.m_hWnd, m_hImageList, TVSIL_NORMAL);
	}

	STDMETHOD(SetObjectRects)(LPCRECT prcPos,LPCRECT prcClip)
	{
		IOleInPlaceObjectWindowlessImpl<CMyTreeControl>::SetObjectRects(prcPos, prcClip);
		int cx, cy;
		cx = prcPos->right - prcPos->left;
		cy = prcPos->bottom - prcPos->top;
		::SetWindowPos(m_ctlSysTreeView32.m_hWnd, NULL, 0,
			0, cx, cy, SWP_NOZORDER | SWP_NOACTIVATE);
		return S_OK;
	}

	HRESULT FinalConstruct()
	{
		return CoCreateFreeThreadedMarshaler(
			GetControllingUnknown(), &m_pUnkMarshaler.p);
	}

	void FinalRelease()
	{
		m_pUnkMarshaler.Release();
	}

	CComPtr<IUnknown> m_pUnkMarshaler;

// IViewObjectEx
	DECLARE_VIEW_STATUS(VIEWSTATUS_SOLIDBKGND | VIEWSTATUS_OPAQUE)

// IMyTreeControl
public:
	STDMETHOD(SetItemName)(/*[in, string]*/ BSTR bstrName);
	STDMETHOD(GetITemName)(/*[out, retval]*/ BSTR* pbstrName);
	LONG m_nBackStyle;
	OLE_COLOR m_clrBorderColor;
	LONG m_nBorderStyle;
	BOOL m_bBorderVisible;
	LONG m_nBorderWidth;
	BOOL m_bEnabled;
	OLE_COLOR m_clrFillColor;
	LONG m_nFillStyle;
	OLE_COLOR m_clrForeColor;

	LRESULT OnLButtonDblClk(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		// TODO : Add Code for message handler. Call DefWindowProc if necessary.
		return 0;
	}
	
	LRESULT OnMouseMove(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		HTREEITEM hTreeItem;
		HCURSOR hCursor;

		if(m_bDragging)
		{			
			TV_HITTESTINFO tvht;
			POINT pt;
			// saving the mouse coordinate
			GetCursorPos(&pt) ;			
			tvht.pt = pt;

			ImageList_DragMove(tvht.pt.x, tvht.pt.y);
			ScreenToClient(&tvht.pt);
			// did we select an item?
			hTreeItem = TreeView_HitTest(this->m_ctlSysTreeView32.m_hWnd, &tvht);		
			if(hTreeItem != NULL)
			{
				ImageList_DragShowNolock(FALSE);
//				if(m_hTreeItemOldDrop == NULL)
//				{
					// The item that is the target of a drag-and-drop operation
					m_hTreeItemOldDrop = TreeView_GetDropHilight(m_ctlSysTreeView32.m_hWnd);
//				}
	
				if(m_hTreeItemOldDrop)
				{	
					// If the hitem parameter is NULL, the control is set to have 
					// no selected item. 
					TreeView_SelectDropTarget(m_ctlSysTreeView32.m_hWnd, hTreeItem);
					// Select item to be drop
					m_hTreeItemDrop = hTreeItem;
				}
				
				if(m_idTimer && hTreeItem == m_hTreeItemOldDrop)
				{
					KillTimer(m_idTimer);	// KillTimer(HWND hWnd, UINT uIDEvent); 
					m_idTimer = 0;
				}
				
				if(!m_idTimer)
					m_idTimer = ::SetTimer(m_ctlSysTreeView32.m_hWnd, 1000, 2000, NULL); 
				ImageList_DragShowNolock(TRUE);
			}
			RECT IsPtInRect;
			::GetClientRect(this->m_hWnd, &IsPtInRect); // this->m_hWnd is CMyTreeControl itself, not m_ctlSysTreeView32.m_hWnd control
			
			m_hTreeItemOldDrop = TreeView_GetDropHilight(m_ctlSysTreeView32.m_hWnd);
			if(!::PtInRect(&IsPtInRect, tvht.pt))
			{
				m_hTreeItemOldDrop = NULL;
				m_hTreeItemDrop = NULL;
				ImageList_DragShowNolock(FALSE);
				hCursor = LoadCursor(_Module.GetResourceInstance(), MAKEINTRESOURCE(IDC_NODROP));
				SetCursor(hCursor);
				ShowCursor(TRUE);
			}
			else
			{
				if(m_hTreeItemOldDrop == NULL)
				{	
					m_hTreeItemOldDrop = TreeView_GetDropHilight(m_ctlSysTreeView32.m_hWnd);	
					m_hTreeItemOldDrop = TreeView_GetParent(m_ctlSysTreeView32.m_hWnd, m_hTreeItemOldDrop);
				}
				ImageList_DragShowNolock(TRUE);
				hCursor = LoadCursor(_Module.GetResourceInstance(), MAKEINTRESOURCE(IDC_POINTER));
				SetCursor(hCursor);
				ShowCursor(TRUE);
			}
		}
		return 0;
	}
	
	LRESULT OnDestroy(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		return 0;
	}
	
	LRESULT OnRButtonDown(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		POINT ptClick;
		ptClick.x = LOWORD(lParam);
		ptClick.y = HIWORD(lParam);
		::ClientToScreen(m_ctlSysTreeView32.m_hWnd, &ptClick);
		TrackPopupMenuEx(m_hRightMenu, TPM_VERTICAL, ptClick.x, ptClick.y, m_ctlSysTreeView32.m_hWnd, NULL);
		return 0;
	}
	
	LRESULT OnRButtonUp(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		// TODO : Add Code for message handler. Call DefWindowProc if necessary.
		return 0;
	}
	
	LRESULT OnKeyDown(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		// TODO : Add Code for message handler. Call DefWindowProc if necessary.
		HTREEITEM hSel = NULL;
		DWORD dwflgs = wParam;
		if(uMsg == WM_KEYDOWN)
		{
			switch(dwflgs)
			{
				case VK_F2:
				{
					hSel = TreeView_GetSelection(this->m_ctlSysTreeView32.m_hWnd);
					TreeView_EditLabel(this->m_ctlSysTreeView32.m_hWnd, hSel);
				}
			}
		}
		return 0;
	}
	
	LRESULT OnNew(WORD wNotifyCode, WORD wID, HWND hWndCtlr, BOOL& bHandled)
	{
		HTREEITEM hSel = TreeView_GetSelection(m_ctlSysTreeView32.m_hWnd);
		if(hSel)
		{
			CAddTreeItem addKeyDlg;
			if (addKeyDlg.DoModal() == IDOK)
				hSel = this->InsertItem(this->m_ctlSysTreeView32.m_hWnd, addKeyDlg.m_szPath, IMAGE, IMAGESELECT, MAKELPARAM(Key, 0), hSel);
			TreeView_Expand(this->m_ctlSysTreeView32.m_hWnd, hSel, TVE_EXPAND);
			TreeView_SelectItem(this->m_ctlSysTreeView32.m_hWnd, hSel);
			this->m_ctlSysTreeView32.SetFocus();
		}
		return 0;
	}

	LRESULT OnDelete(WORD wNotifyCode, WORD wID, HWND hWndCtlr, BOOL& bHandled)
	{
		HTREEITEM hSel = TreeView_GetSelection(m_ctlSysTreeView32.m_hWnd);
		if(hSel)
		{
			TreeView_DeleteItem(m_ctlSysTreeView32.m_hWnd, hSel);
		}
		return 0;
	}
	
	LRESULT OnOpen(WORD wNotifyCode, WORD wID, HWND hWndCtlr, BOOL& bHandled)
	{
		USES_CONVERSION;
		TCHAR szFullPath[_MAX_PATH];
		szFullPath[0] = NULL;

		if (m_ctlSysTreeView32.m_hWnd == NULL)
			return S_OK;
		
		OPENFILENAME ofn;
		memset(&ofn, 0, sizeof(OPENFILENAME));
		ofn.lStructSize = sizeof(OPENFILENAME);
		ofn.hwndOwner = m_ctlSysTreeView32.m_hWnd;
		ofn.lpstrFilter = m_szFilter;
		ofn.lpstrTitle = _T("Open CPP Extension File Only");
		ofn.lpstrFile = szFullPath;
		ofn.nMaxFile = _MAX_PATH;

		if (!GetOpenFileName(&ofn))
		{
			ATLTRACE(_T("Failed to get open file from Common Dlg\n"));
			return 0;
		}

		m_strPath = szFullPath;
		HTREEITEM hSel = TreeView_GetSelection(this->m_ctlSysTreeView32.m_hWnd);
		if(hSel)
		{
			hSel = this->InsertItem(this->m_ctlSysTreeView32.m_hWnd, OLE2T(m_strPath), 
				IMAGE, IMAGESELECT, MAKELPARAM(Key, 0), hSel);
			TreeView_Expand(this->m_ctlSysTreeView32.m_hWnd, hSel, TVE_EXPAND);
			TreeView_SelectItem(this->m_ctlSysTreeView32.m_hWnd, hSel);
			this->m_ctlSysTreeView32.SetFocus();
		}
		return 0;
	}
	
	LRESULT OnAddKey(WORD wNotifyCode, WORD wID, HWND hWndCtlr, BOOL& bHandled)
	{
		LONG lParam;
		HTREEITEM hSel = TreeView_GetSelection(m_ctlSysTreeView32.m_hWnd);
		GetLParam(hSel, lParam);
		if (hSel)
		{
			CAddTreeItem addKeyDlg;
			if (addKeyDlg.DoModal() == IDOK)
				InsertItem(m_ctlSysTreeView32.m_hWnd, addKeyDlg.m_szPath, IMAGE, IMAGESELECT, MAKELPARAM(Key, 0), hSel);
		}
		return 0;
	}

	LRESULT OnRename(WORD wNotifyCode, WORD wID, HWND hWndCtlr, BOOL& bHandled)
	{
		HTREEITEM hSel = TreeView_GetSelection(this->m_ctlSysTreeView32.m_hWnd);
		TreeView_EditLabel(this->m_ctlSysTreeView32.m_hWnd, hSel);		
		return 0;
	}

	LRESULT OnBegindrag(WPARAM , NMHDR* pNMHDR, BOOL&)
	{
		NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;

		m_hTreeItemDrag = pNMTreeView->itemNew.hItem;
		HTREEITEM htiCheck = TreeView_GetRoot(this->m_ctlSysTreeView32.m_hWnd);
		if(htiCheck)
			if(htiCheck != m_hTreeItemDrag)
			{
				TreeView_SelectDropTarget(this->m_ctlSysTreeView32.m_hWnd, m_hTreeItemDrag);
				m_hTreeItemDrop = NULL;
				m_hImageList = TreeView_CreateDragImage(m_ctlSysTreeView32.m_hWnd, m_hTreeItemDrag);

				if(!m_hImageList)
					return 0;

				m_bDragging = TRUE;
				POINT pt;
				
				
				IMAGEINFO ImageInfo;
				// Get the current state of the image.
				if(this->TreeView_GetCheckState(this->m_ctlSysTreeView32.m_hWnd, pNMTreeView->itemNew.hItem)) 
					ImageList_GetImageInfo(m_hImageList, 1, &ImageInfo); // Retrieves information about an image.
				else
					ImageList_GetImageInfo(m_hImageList, 0, &ImageInfo);
				
				// Get the center of Image's Rectangle
				pt.x = (ImageInfo.rcImage.right - ImageInfo.rcImage.left) / 2;
				pt.y = (ImageInfo.rcImage.bottom - ImageInfo.rcImage.top) / 2;
 
				ImageList_BeginDrag(m_hImageList, 0, pt.x, pt.y);

				pt = pNMTreeView->ptDrag;
				ClientToScreen(&pt);
				ImageList_DragEnter(NULL, pt.x, pt.y);	
				m_hWindow = NULL;
				m_hWindow = ::SetCapture(m_ctlSysTreeView32.m_hWnd);
			}
		return 0;
	}
	
	LRESULT OnLButtonUP(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		// TODO : Add Code for message handler. Call DefWindowProc if necessary.
		if(m_bDragging)
		{
			m_bDragging = FALSE;
			ImageList_DragLeave(m_hWindow);
			ImageList_EndDrag();
			// Release the drag image
			ReleaseCapture();

			// If no item in tree is the select target to drop, do nothing
			// Else start copy a dragging item to newly location
			if(m_hTreeItemOldDrop != m_hTreeItemDrag)
			{	
				// If Drag item is an ancestor of Drop item then return
				HTREEITEM htiParent = m_hTreeItemDrop;
				while((htiParent = TreeView_GetParent(this->m_ctlSysTreeView32.m_hWnd, htiParent)) != NULL)
				{
					/****************************************************/
					//		Parent				// Not allow Parent to drop on 
					//			Child One		// its own child. In this case
					//				Child Two	// is item One, Item Two and
					//			Child Three		// Item Three
					/****************************************************/
					if(htiParent == m_hTreeItemDrag) 
						return 0;
				}
				// Expand the branch to see all the chain items
				TreeView_Expand(this->m_ctlSysTreeView32.m_hWnd, m_hTreeItemDrop, TVE_EXPAND) ;
				HTREEITEM htiNew = this->CopyBranch(m_hTreeItemDrag, m_hTreeItemDrop);
				// The handle of an item dragged, it was copy to the new location, 
				// so delete it because it no longer needed
				TreeView_DeleteItem(m_ctlSysTreeView32.m_hWnd, m_hTreeItemDrag);
				// Hilight the new item just copy to let the user know the 
				// item dragged was copy to the new location successfully
				TreeView_SelectItem(m_ctlSysTreeView32.m_hWnd, htiNew);
				// Release the image handle when no longer need
				m_hImageList = NULL;
			}
		}
		m_hTreeItemOldDrop = NULL;
		TreeView_SelectDropTarget(this->m_ctlSysTreeView32.m_hWnd, (HTREEITEM)NULL);
		FireViewChange();
		return 0;
	}

	LRESULT OnEndEditLabel(WPARAM, LPNMHDR pnmh, BOOL&)
	{
		FireViewChange();
		// Return 1 mean we already take care the message
		return 1;
	}

	BOOL GetItemText(HTREEITEM hItem, BSTR& bstrText) const
	{
		USES_CONVERSION;
		ATLASSERT(::IsWindow(m_hWnd));
		ATLASSERT(bstrText == NULL);
		TV_ITEM item;
		item.hItem = hItem;
		item.mask = TVIF_TEXT;
		LPTSTR lpstrText = NULL;
		int nLen = 48;
		do
		{
			LPTSTR lpstrTemp;
			lpstrTemp = (LPTSTR)realloc(lpstrText, nLen * sizeof(TCHAR));
			if(lpstrTemp == NULL)
			{
				free(lpstrText);
				return FALSE;
			}
			lpstrText = lpstrTemp;
			item.pszText = lpstrText;
			item.cchTextMax = nLen;
			::SendMessage(m_ctlSysTreeView32.m_hWnd, TVM_GETITEM, 0, (LPARAM)&item);
		}
		while(lstrlen(item.pszText) == (nLen-1))
			;

		bstrText = ::SysAllocString(T2OLE(lpstrText));
		free(lpstrText);

		return (bstrText != NULL) ? TRUE : FALSE;
	}

	LRESULT OnDraw(ATL_DRAWINFO& di)
	{
		RECT& rc = *(RECT*)di.prcBounds;
		DrawEdge(di.hdcDraw, &rc, EDGE_SUNKEN, BF_RECT | BF_ADJUST);
		return S_OK;
	}

	BOOL TreeView_SetCheckState(HWND hwndTreeView, HTREEITEM hItem, BOOL fCheck)
	{
		 TVITEM tvItem;

		 tvItem.mask = TVIF_HANDLE | TVIF_STATE;
		 tvItem.hItem = hItem;
		 tvItem.stateMask = TVIS_STATEIMAGEMASK;
		 
		 /*
		 Since state images are zero-based, 0 in this macro turns the check off, and 
		 1 turns it on.
		 */
		 tvItem.state = INDEXTOSTATEIMAGEMASK((fCheck ? 1 : 0));
		 return TreeView_SetItem(hwndTreeView, &tvItem);
	}

	BOOL TreeView_GetCheckState(HWND hwndTreeView, HTREEITEM hItem)
	{
		 TVITEM tvItem;

		 // Prepare to receive the desired information.
		 tvItem.mask = TVIF_HANDLE | TVIF_STATE;
		 tvItem.hItem = hItem;
		 tvItem.stateMask = TVIS_STATEIMAGEMASK;

		 // Request the information.
		 TreeView_GetItem(hwndTreeView, &tvItem);

		 // Return zero if it's not checked, or nonzero otherwise.
		 return ((BOOL)(tvItem.state >> 12) -1);
	}

	// Copy item from one location to another location of the tree
	HTREEITEM CopyBranch(HTREEITEM hDragItem, HTREEITEM hDropItem, HTREEITEM htiAfter = TVI_LAST)
	{
		HTREEITEM hChild;
      HTREEITEM hNewItem = CopyItem(hDragItem, hDropItem, htiAfter);
      hChild = TreeView_GetChild(this->m_ctlSysTreeView32.m_hWnd, hDragItem);        
		while(hChild != NULL)        
		{
			// recursively transfer all the items
			CopyBranch(hChild, hNewItem);  
			hChild = TreeView_GetNextSibling(this->m_ctlSysTreeView32.m_hWnd, hChild);
		}
        return hNewItem;
	}

	HTREEITEM CopyItem(HTREEITEM hti, HTREEITEM htiNewParent, HTREEITEM htiAfter)
	{
		USES_CONVERSION;
		LONG lparam = 0L;
		HTREEITEM hTreeItemNew = NULL;
		LPTSTR lpszItemText = NULL;
		CComBSTR bstrItemText;
		// Get item text of
		this->GetItemText(hti, bstrItemText.m_str);
		lpszItemText = OLE2T(bstrItemText);
		this->GetLParam(hti, lparam);
		hTreeItemNew = this->InsertItem(this->m_ctlSysTreeView32.m_hWnd, lpszItemText, IMAGE,    
													IMAGESELECT, MAKELPARAM(DefaultVal, 0L), htiNewParent);
		this->SetLParam(hTreeItemNew, MAKELPARAM(lparam, 0L));
		TreeView_SetCheckState(this->m_ctlSysTreeView32.m_hWnd, hTreeItemNew, FALSE);

		return hTreeItemNew;
	}
};

#endif //__MYTREECONTROL_H_
