// Tree.H : Declaration of the CTree class

#ifndef __TREE_H_
#define __TREE_H_

class CTreeAccessor
{
public:
/***********************************************************
*	Again, when AppWizard generated this class header, no
* Constructor at all, so I have to add manually by hand
* to initialize its data member
************************************************************/
	CTreeAccessor()	: 
		m_ITEMNODE(0),
		m_INDENTLEVEL(0),
		m_ITEMDATA(0L)
	{
		memset(m_ITEMNAME, 0, 48);
	}
public:
	TCHAR m_ITEMNAME[48];
	SHORT m_ITEMNODE;
	SHORT m_INDENTLEVEL;
	LONG	m_ITEMDATA;

BEGIN_COLUMN_MAP(CTreeAccessor)
	COLUMN_ENTRY(1, m_ITEMNODE)
	COLUMN_ENTRY(2, m_ITEMNAME)
	COLUMN_ENTRY(3, m_INDENTLEVEL)
	COLUMN_ENTRY(4, m_ITEMDATA)
END_COLUMN_MAP()

DEFINE_COMMAND(CTreeAccessor, _T(" \
	SELECT \
		ITEM_NODE, \
		ITEM_NAME, \
		INDENT_LEVEL, \
		ITEM_DATA  \
		FROM Tree"))

	// You may wish to call this function if you are inserting a record and wish to
	// initialize all the fields, if you are not going to explicitly set all of them.
	void ClearRecord()
	{
		memset(this, 0, sizeof(*this));
	}
};

class CTree : public CCommand<CAccessor<CTreeAccessor> >
{
public:
	CTree()
	{}
	
	~CTree()
	{}
	
	HRESULT Open()
	{
		HRESULT		hr;

		hr = OpenDataSource();
		if (FAILED(hr))
			return hr;

		return OpenRowset();
	}
	
/********************************************************/
//	All the comment lines in OpenDataSource() is AppWizard Generated 
//	for free, but depend on the need, I comment them and provide 
// my own functionality
/********************************************************/
	HRESULT OpenDataSource()
	{
		HRESULT		hr;
		CDataSource db;
		CDBPropSet	dbinit(DBPROPSET_DBINIT);

		dbinit.AddProperty(DBPROP_AUTH_CACHE_AUTHINFO, true);
		dbinit.AddProperty(DBPROP_AUTH_ENCRYPT_PASSWORD, false);
		dbinit.AddProperty(DBPROP_AUTH_MASK_PASSWORD, false);
		dbinit.AddProperty(DBPROP_AUTH_PASSWORD, OLESTR(""));
		dbinit.AddProperty(DBPROP_AUTH_PERSIST_ENCRYPTED, false);
		dbinit.AddProperty(DBPROP_AUTH_PERSIST_SENSITIVE_AUTHINFO, false);
		dbinit.AddProperty(DBPROP_AUTH_USERID, OLESTR("Admin"));
		dbinit.AddProperty(DBPROP_INIT_DATASOURCE, OLESTR("C:\\WINNT\\Profiles\\cql.000\\Personal\\Tree.mdb"));
		dbinit.AddProperty(DBPROP_INIT_MODE, (long)16);
		dbinit.AddProperty(DBPROP_INIT_PROMPT, (short)4);
		dbinit.AddProperty(DBPROP_INIT_PROVIDERSTRING, OLESTR(";COUNTRY=0;CP=1252;LANGID=0x0409"));
		dbinit.AddProperty(DBPROP_INIT_LCID, (long)1033);

		hr = db.Open(_T("Microsoft.Jet.OLEDB.3.51"), &dbinit);
		if(FAILED(hr))
			return hr;

		return m_session.Open(db);
	}
	HRESULT OpenRowset()
	{
		return CCommand<CAccessor<CTreeAccessor> >::Open(m_session);
	}
	CSession	m_session;
};

class CTreeInsertAccessor
{
public:
	CTreeInsertAccessor()	: 
		m_ITEMNODE(0),
		m_INDENTLEVEL(0),
		m_ITEMDATA(0L)
	{
		memset(m_ITEMNAME, 0, 48);
	}
public:
	TCHAR m_ITEMNAME[48];
	SHORT m_ITEMNODE;
	SHORT m_INDENTLEVEL;
	LONG	m_ITEMDATA;

BEGIN_PARAM_MAP(CTreeInsertAccessor)
	COLUMN_ENTRY(1, m_ITEMNODE)
	COLUMN_ENTRY(2, m_ITEMNAME)
	COLUMN_ENTRY(3, m_INDENTLEVEL)
	COLUMN_ENTRY(4, m_ITEMDATA)
END_PARAM_MAP()

	void ClearRecord()
	{	memset(this, 0, sizeof(*this));	}
};

class CTreeDeleteAccessor
{
public:
DEFINE_COMMAND(CTreeAccessor, _T(" \
	DELETE \
	FROM \
	Tree"))
};

class COutParamAccessor
{
public:
	LONG m_Param;

BEGIN_COLUMN_MAP(COutParamAccessor)
	COLUMN_ENTRY(1, m_Param)
END_COLUMN_MAP()
};

#endif // __TREE_H_
